diff lib-src/rcs2log @ 171:929b76928fce r20-3b12

Import from CVS: tag r20-3b12
author cvs
date Mon, 13 Aug 2007 09:47:52 +0200
parents 376386a54a3c
children
line wrap: on
line diff
--- a/lib-src/rcs2log	Mon Aug 13 09:47:00 2007 +0200
+++ b/lib-src/rcs2log	Mon Aug 13 09:47:52 2007 +0200
@@ -1,8 +1,9 @@
-#!/bin/sh
+#! /bin/sh
 
 # RCS to ChangeLog generator
 
-# Generate a change log prefix from RCS files and the ChangeLog (if any).
+# Generate a change log prefix from RCS files (perhaps in the CVS repository)
+# and the ChangeLog (if any).
 # Output the new prefix to standard output.
 # You can edit this prefix by hand, and then prepend it to ChangeLog.
 
@@ -10,71 +11,130 @@
 # Clump together log entries that start with `{topic} ',
 # where `topic' contains neither white space nor `}'.
 
-# Author: Paul Eggert <eggert@twinsun.com>
+Help='The default FILEs are the files registered under the working directory.
+Options:
 
-# !Id: rcs2log,v 1.18 1994/08/15 22:44:10 eggert Exp !
+  -c CHANGELOG  Output a change log prefix to CHANGELOG (default ChangeLog).
+  -h HOSTNAME  Use HOSTNAME in change log entries (default current host).
+  -i INDENT  Indent change log lines by INDENT spaces (default 8).
+  -l LENGTH  Try to limit log lines to LENGTH characters (default 79).
+  -R  If no FILEs are given and RCS is used, recurse through working directory.
+  -r OPTION  Pass OPTION to subsidiary log command.
+  -t TABWIDTH  Tab stops are every TABWIDTH characters (default 8).
+  -u "LOGIN<tab>FULLNAME<tab>MAILADDR"  Assume LOGIN has FULLNAME and MAILADDR.
+  -v  Append RCS revision to file names in log lines.
+  --help  Output help.
+  --version  Output version number.
 
-# Copyright 1992, 1993 Free Software Foundation, Inc.
+Report bugs to <bug-gnu-emacs@prep.ai.mit.edu>.'
+
+Id='$Id: rcs2log,v 1.2 1997/07/09 04:31:03 steve Exp $'
+
+# Copyright 1992, 1993, 1994, 1995, 1996, 1997 Free Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2, or (at your option)
 # any later version.
-# 
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
-# along with this program; see the file COPYING.  If not, write to
-# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+# along with this program; see the file COPYING.  If not, write to the
+# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
 
+Copyright='Copyright 1997 Free Software Foundation, Inc.
+This program comes with NO WARRANTY, to the extent permitted by law.
+You may redistribute copies of this program
+under the terms of the GNU General Public License.
+For more information about these matters, see the files named COPYING.
+Author: Paul Eggert <eggert@twinsun.com>'
+
+tab='	'
 nl='
 '
 
 # Parse options.
 
 # defaults
+: ${AWK=awk}
 : ${TMPDIR=/tmp}
+changelog=ChangeLog # change log file name
+datearg= # rlog date option
 hostname= # name of local host (if empty, will deduce it later)
 indent=8 # indent of log line
-initialize_fullname= # awk assignments to set up fullname array
-initialize_mailaddr= # awk assignments to set up mailaddr array
 length=79 # suggested max width of log line
-logins= # login names for people we know fullnames and mailaddresses of
-loginsout= # temporary file holding sorted logins
+logins= # login names for people we know fullnames and mailaddrs of
+loginFullnameMailaddrs= # login<tab>fullname<tab>mailaddr triplets
+logTZ= # time zone for log dates (if empty, use local time)
+recursive= # t if we want recursive rlog
+revision= # t if we want revision numbers
 rlog_options= # options to pass to rlog
 tabwidth=8 # width of horizontal tab
 
 while :
 do
 	case $1 in
-	-i)	indent=${2?};;
-	-h)	hostname=${2?};;
-	-l)	length=${2?};;
-	-n)	logins=$logins$nl${2?}
-		loginsout=$TMPDIR/rcs2log$$l
-		case $2${3?}${4?} in
-		*\"* | *\\* | *"$nl"*)
-			echo >&2 "$0: -n '$2' '$3' '$4': special characters not allowed"
-			exit 1
+	-c)	changelog=${2?}; shift;;
+	-i)	indent=${2?}; shift;;
+	-h)	hostname=${2?}; shift;;
+	-l)	length=${2?}; shift;;
+	-[nu])	# -n is obsolescent; it is replaced by -u.
+		case $1 in
+		-n)	case ${2?}${3?}${4?} in
+			*"$tab"* | *"$nl"*)
+				echo >&2 "$0: -n '$2' '$3' '$4': tabs, newlines not allowed"
+				exit 1
+			esac
+			loginFullnameMailaddrs=$loginFullnameMailaddrs$nl$2$tab$3$tab$4
+			shift; shift; shift;;
+		-u)
+			# If $2 is not tab-separated, use colon for separator.
+			case ${2?} in
+			*"$nl"*)
+				echo >&2 "$0: -u '$2': newlines not allowed"
+				exit 1;;
+			*"$tab"*)
+				t=$tab;;
+			*)
+				t=:
+			esac
+			case $2 in
+			*"$t"*"$t"*"$t"*)
+				echo >&2 "$0: -u '$2': too many fields"
+				exit 1;;
+			*"$t"*"$t"*)
+				;;
+			*)
+				echo >&2 "$0: -u '$2': not enough fields"
+				exit 1
+			esac
+			loginFullnameMailaddrs=$loginFullnameMailaddrs$nl$2
+			shift
 		esac
-		initialize_fullname="$initialize_fullname
-			fullname[\"$2\"] = \"$3\""
-		initialize_mailaddr="$initialize_mailaddr
-			mailaddr[\"$2\"] = \"$4\""
-		shift; shift;;
-	-r)	rlog_options=$rlog_options$nl${2?};;
-	-t)	tabwidth=${2?};;
-	-*)	echo >&2 "$0: usage: $0 [options] [file ...]
-Options:
-	[-h hostname] [-i indent] [-l length] [-n login fullname mailaddr]...
-	[-r rlog_option]... [-t tabwidth]"
-		exit 1;;
+		logins=$logins$nl$login
+		;;
+	-r)	rlog_options=$rlog_options$nl${2?}; shift;;
+	-R)	recursive=t;;
+	-t)	tabwidth=${2?}; shift;;
+	-v)	revision=t;;
+	--version)
+		set $Id
+		rcs2logVersion=$3
+		echo >&2 "rcs2log (GNU Emacs) $rcs2logVersion$nl$Copyright"
+		exit 0;;
+	-*)	echo >&2 "Usage: $0 [OPTION]... [FILE ...]$nl$Help"
+		case $1 in
+		--help) exit 0;;
+		*) exit 1
+		esac;;
 	*)	break
 	esac
-	shift; shift
+	shift
 done
 
 month_data='
@@ -82,77 +142,90 @@
 	m[3]="Apr"; m[4]="May"; m[5]="Jun"
 	m[6]="Jul"; m[7]="Aug"; m[8]="Sep"
 	m[9]="Oct"; m[10]="Nov"; m[11]="Dec"
-
-	# days in non-leap year thus far, indexed by month (0-12)
-	mo[0]=0; mo[1]=31; mo[2]=59; mo[3]=90
-	mo[4]=120; mo[5]=151; mo[6]=181; mo[7]=212
-	mo[8]=243; mo[9]=273; mo[10]=304; mo[11]=334
-	mo[12]=365
 '
 
 
-# Log into $rlogout the revisions checked in since the first ChangeLog entry.
+# Put rlog output into $rlogout.
 
-date=1970
-if test -s ChangeLog
+# If no rlog options are given,
+# log the revisions checked in since the first ChangeLog entry.
+# Since ChangeLog is only by date, some of these revisions may be duplicates of
+# what's already in ChangeLog; it's the user's responsibility to remove them.
+case $rlog_options in
+'')
+	if test -s "$changelog"
+	then
+		e='
+			/^[0-9]+-[0-9][0-9]-[0-9][0-9]/{
+				# ISO 8601 date
+				print $1
+				exit
+			}
+			/^... ... [ 0-9][0-9] [ 0-9][0-9]:[0-9][0-9]:[0-9][0-9] [0-9]+ /{
+				# old-fashioned date and time (Emacs 19.31 and earlier)
+				'"$month_data"'
+				year = $5
+				for (i=0; i<=11; i++) if (m[i] == $2) break
+				dd = $3
+				printf "%d-%02d-%02d\n", year, i+1, dd
+				exit
+			}
+		'
+		d=`$AWK "$e" <"$changelog"` || exit
+		case $d in
+		?*) datearg="-d>$d"
+		esac
+	fi
+esac
+
+# Use TZ specified by ChangeLog local variable, if any.
+if test -s "$changelog"
 then
-	# Add 1 to seconds to avoid duplicating most recent log.
-	e='
-		/^... ... [ 0-9][0-9] [ 0-9][0-9]:[0-9][0-9]:[0-9][0-9] [0-9]+ /{
-			'"$month_data"'
-			year = $5
-			for (i=0; i<=11; i++) if (m[i] == $2) break
-			dd = $3
-			hh = substr($0,12,2)
-			mm = substr($0,15,2)
-			ss = substr($0,18,2)
-			ss++
-			if (ss == 60) {
-				ss = 0
-				mm++
-				if (mm == 60) {
-					mm = 0
-					hh++
-					if (hh == 24) {
-						hh = 0
-						dd++
-						monthdays = mo[i+1] - mo[i]
-						if (i == 1 && year%4 == 0 && (year%100 != 0 || year%400 == 0)) monthdays++
-						if (dd == monthdays + 1) {
-							dd = 1
-							i++
-							if (i == 12) {
-								i = 0
-								year++
-							}
-						}
-					}
-				}
-			}
-			printf "%d/%02d/%02d %02d:%02d:%02d\n", year, i+1, dd, hh, mm, ss
-			exit
+	extractTZ='
+		/^.*change-log-time-zone-rule['"$tab"' ]*:['"$tab"' ]*"\([^"]*\)".*/{
+			s//\1/; p; q
+		}
+		/^.*change-log-time-zone-rule['"$tab"' ]*:['"$tab"' ]*t.*/{
+			s//UTC0/; p; q
 		}
 	'
-	d=`awk "$e" <ChangeLog` || exit
-	case $d in
-	?*) date=$d
+	logTZ=`tail "$changelog" | sed -n "$extractTZ"`
+	case $logTZ in
+	?*) TZ=$logTZ; export TZ
 	esac
 fi
-datearg="-d>$date"
 
-repository=
-rlog=rlog
-case $CVSROOT in
-?*)
-	if test -d "$CVSROOT" && test -f CVS/Repository
-	then
-		r=`cat <CVS/Repository` || exit
-		if test -d "$CVSROOT/$r"
+# If CVS is in use, examine its repository, not the normal RCS files.
+if test ! -f CVS/Repository
+then
+	rlog=rlog
+	repository=
+else
+	rlog='cvs -q log'
+	repository=`sed 1q <CVS/Repository` || exit
+	test ! -f CVS/Root || CVSROOT=`cat <CVS/Root` || exit
+	case $CVSROOT in
+	*:/*)
+		# remote repository
+		;;
+	*)
+		# local repository
+		case $repository in
+		/*) ;;
+		*) repository=${CVSROOT?}/$repository
+		esac
+		if test ! -d "$repository"
 		then
-			repository=$CVSROOT/$r
-			rlog='cvs log'
+			echo >&2 "$0: $repository: bad repository (see CVS/Repository)"
+			exit 1
 		fi
-	fi
+	esac
+fi
+
+# Use $rlog's -zLT option, if $rlog supports it.
+case `$rlog -zLT 2>&1` in
+*' option'*) ;;
+*) rlog_options=-zLT$nl$rlog_options
 esac
 
 # With no arguments, examine all files under the RCS directory.
@@ -160,30 +233,59 @@
 0)
 	case $repository in
 	'')
-		files=
-		for file in RCS/.* RCS/* .*,v *,v
-		do
-			case $file in
-			RCS/. | RCS/..) continue;;
-			RCS/.\* | RCS/\* | .\*,v | \*,v) test -f "$file" || continue
-			esac
-			files=$files$nl$file
-		done
-		case $files in
-		'') exit 0
-		esac
 		oldIFS=$IFS
 		IFS=$nl
-		set $files
+		case $recursive in
+		t)
+			RCSdirs=`find . -name RCS -type d -print`
+			filesFromRCSfiles='s|,v$||; s|/RCS/|/|; s|^\./||'
+			files=`
+				{
+					case $RCSdirs in
+					?*) find $RCSdirs \
+							-type f \
+							! -name '*_' \
+							! -name ',*,' \
+							! -name '.*_' \
+							! -name .rcsfreeze.log \
+							! -name .rcsfreeze.ver \
+							-print
+					esac
+					find . -name '*,v' -print
+				} |
+				sort -u |
+				sed "$filesFromRCSfiles"
+			`;;
+		*)
+			files=
+			for file in RCS/.* RCS/* .*,v *,v
+			do
+				case $file in
+				RCS/. | RCS/.. | RCS/,*, | RCS/*_) continue;;
+				RCS/.rcsfreeze.log | RCS/.rcsfreeze.ver) continue;;
+				RCS/.\* | RCS/\* | .\*,v | \*,v) test -f "$file" || continue
+				esac
+				files=$files$nl$file
+			done
+			case $files in
+			'') exit 0
+			esac
+		esac
+		set x $files
+		shift
 		IFS=$oldIFS
 	esac
 esac
 
+llogout=$TMPDIR/rcs2log$$l
 rlogout=$TMPDIR/rcs2log$$r
 trap exit 1 2 13 15
-trap "rm -f $loginsout $rlogout; exit 1" 0
+trap "rm -f $llogout $rlogout; exit 1" 0
 
-$rlog "$datearg" $rlog_options ${1+"$@"} >$rlogout || exit
+case $datearg in
+?*) $rlog $rlog_options "$datearg" ${1+"$@"} >$rlogout;;
+'') $rlog $rlog_options ${1+"$@"} >$rlogout
+esac || exit
 
 
 # Get the full name of each author the logs mention, and set initialize_fullname
@@ -191,27 +293,63 @@
 # Warning: foreign authors (i.e. not known in the passwd file) are mishandled;
 # you have to fix the resulting output by hand.
 
-case $loginsout in
-?*) sort -u -o $loginsout <<EOF || exit
+initialize_fullname=
+initialize_mailaddr=
+
+case $loginFullnameMailaddrs in
+?*)
+	case $loginFullnameMailaddrs in
+	*\"* | *\\*)
+		sed 's/["\\]/\\&/g' >$llogout <<EOF || exit
+$loginFullnameMailaddrs
+EOF
+		loginFullnameMailaddrs=`cat $llogout`
+	esac
+
+	oldIFS=$IFS
+	IFS=$nl
+	for loginFullnameMailaddr in $loginFullnameMailaddrs
+	do
+		case $loginFullnameMailaddr in
+		*"$tab"*) IFS=$tab;;
+		*) IFS=:
+		esac
+		set x $loginFullnameMailaddr
+		login=$2
+		fullname=$3
+		mailaddr=$4
+		initialize_fullname="$initialize_fullname
+			fullname[\"$login\"] = \"$fullname\""
+		initialize_mailaddr="$initialize_mailaddr
+			mailaddr[\"$login\"] = \"$mailaddr\""
+	done
+	IFS=$oldIFS
+esac
+
+case $llogout in
+?*) sort -u -o $llogout <<EOF || exit
 $logins
 EOF
 esac
+output_authors='/^date: / {
+	if ($2 ~ /^[0-9]*[-\/][0-9][0-9][-\/][0-9][0-9]$/ && $3 ~ /^[0-9][0-9]:[0-9][0-9]:[0-9][0-9][-+0-9:]*;$/ && $4 == "author:" && $5 ~ /^[^;]*;$/) {
+		print substr($5, 1, length($5)-1)
+	}
+}'
 authors=`
-	sed -n 's|^date: *[0-9]*[-/][0-9][0-9][-/][0-9][0-9] [0-9][0-9]:[0-9][0-9]:[0-9][0-9][-+0-9]*; *author: *\([^; ]*\).*|\1|p' <$rlogout |
-	case $loginsout in
+	$AWK "$output_authors" <$rlogout |
+	case $llogout in
 	'') sort -u;;
-	?*) sort -u | comm -23 - $loginsout
+	?*) sort -u | comm -23 - $llogout
 	esac
 `
 case $authors in
 ?*)
-	initialize_author=
-	for author in $authors
-	do
-		initialize_author="$initialize_author
-			author[\"$author\"] = 1
-		"
-	done
+	cat >$llogout <<EOF || exit
+$authors
+EOF
+	initialize_author_script='s/["\\]/\\&/g; s/.*/author[\"&\"] = 1/'
+	initialize_author=`sed -e "$initialize_author_script" <$llogout`
 	awkscript='
 		BEGIN {
 			alphabet = "abcdefghijklmnopqrstuvwxyz"
@@ -239,15 +377,39 @@
 					if (i) A = substr(ALPHABET, i, 1)
 					fullname = substr(fullname, 1, abbr-1) A substr($1, 2) substr(fullname, abbr+1)
 				}
-				printf "fullname[\"%s\"] = \"%s\"\n", $1, fullname
+
+				# Quote quotes and backslashes properly in full names.
+				# Do not use gsub; traditional awk lacks it.
+				quoted = ""
+				rest = fullname
+				for (;;) {
+					p = index(rest, "\\")
+					q = index(rest, "\"")
+					if (p) {
+						if (q && q<p) p = q
+					} else {
+						if (!q) break
+						p = q
+					}
+					quoted = quoted substr(rest, 1, p-1) "\\" substr(rest, p, 1)
+					rest = substr(rest, p+1)
+				}
+
+				printf "fullname[\"%s\"] = \"%s%s\"\n", $1, quoted, rest
 				author[$1] = 0
 			}
 		}
 	'
 
 	initialize_fullname=`
-		(cat /etc/passwd; ypmatch $authors passwd) 2>/dev/null |
-		awk -F: "$awkscript"
+		(
+			cat /etc/passwd
+			for author in $authors
+			do nismatch $author passwd.org_dir
+			done
+			ypmatch $authors passwd
+		) 2>/dev/null |
+		$AWK -F: "$awkscript"
 	`$initialize_fullname
 esac
 
@@ -278,7 +440,7 @@
 	# Print each line of the log, transliterating \r to \n.
 	while ((i = index(Log, CR)) != 0) {
 		logline = substr(Log, 1, i-1)
-		if (logline ~ /[^	 ]/) {
+		if (logline ~ /[^'"$tab"' ]/) {
 			printf "%s%s\n", sep, logline
 		} else {
 			print ""
@@ -288,6 +450,9 @@
 	}
 }'
 
+# Pattern to match the `revision' line of rlog output.
+rlog_revision_pattern='^revision [0-9]+\.[0-9]+(\.[0-9]+\.[0-9]+)*(['"$tab"' ]+locked by: [^'"$tab"' $,.0-9:;@]*[^'"$tab"' $,:;@][^'"$tab"' $,.0-9:;@]*;)?['"$tab"' ]*$'
+
 case $hostname in
 '')
 	hostname=`(
@@ -296,6 +461,15 @@
 		echo >&2 "$0: cannot deduce hostname"
 		exit 1
 	}
+
+	case $hostname in
+	*.*) ;;
+	*)
+		domainname=`(domainname) 2>/dev/null` &&
+		case $domainname in
+		*.*) hostname=$hostname.$domainname
+		esac
+	esac
 esac
 
 
@@ -304,44 +478,74 @@
 # First, reformat the rlog output so that each line contains one log entry.
 # Transliterate \n to \r so that multiline entries fit on a single line.
 # Discard irrelevant rlog output.
-awk <$rlogout '
-	/^Working file:/ { filename = $3 }
-	/^date: /, /^(-----------*|===========*)$/ {
-		if ($0 ~ /^branches: /) { next }
+$AWK <$rlogout '
+	BEGIN { repository = "'"$repository"'" }
+	/^RCS file:/ {
+		if (repository != "") {
+			filename = $3
+			if (substr(filename, 1, length(repository) + 1) == repository "/") {
+				filename = substr(filename, length(repository) + 2)
+			}
+			if (filename ~ /,v$/) {
+				filename = substr(filename, 1, length(filename) - 2)
+			}
+			if (filename ~ /(^|\/)Attic\/[^\/]*$/) {
+				i = length(filename)
+				while (substr(filename, i, 1) != "/") i--
+				filename = substr(filename, 1, i - 6) substr(filename, i + 1)
+			}
+		}
+		rev = "?"
+	}
+	/^Working file:/ { if (repository == "") filename = $3 }
+	/'"$rlog_revision_pattern"'/, /^(-----------*|===========*)$/ {
+		if ($0 ~ /'"$rlog_revision_pattern"'/) {
+			rev = $2
+			next
+		}
 		if ($0 ~ /^date: [0-9][- +\/0-9:]*;/) {
 			date = $2
-			if (date ~ /-/) {
-				# An ISO format date.  Replace all "-"s with "/"s.
+			if (date ~ /\//) {
+				# This is a traditional RCS format date YYYY/MM/DD.
+				# Replace "/"s with "-"s to get ISO format.
 				newdate = ""
-				while ((i = index(date, "-")) != 0) {
-					newdate = newdate substr(date, 1, i-1) "/"
+				while ((i = index(date, "/")) != 0) {
+					newdate = newdate substr(date, 1, i-1) "-"
 					date = substr(date, i+1)
 				}
 				date = newdate date
 			}
-			# Ignore any time zone; ChangeLog has no room for it.
-			time = substr($3, 1, 8)
+			time = substr($3, 1, length($3) - 1)
 			author = substr($5, 1, length($5)-1)
-			printf "%s %s %s %s %c", filename, date, time, author, 13
+			printf "%s %s %s %s %s %c", filename, rev, date, time, author, 13
+			rev = "?"
 			next
 		}
+		if ($0 ~ /^branches: /) { next }
 		if ($0 ~ /^(-----------*|===========*)$/) { print ""; next }
+		if ($0 == "Initial revision" || $0 ~ /^file .+ was initially added on branch .+\.$/) {
+			$0 = "New file."
+        }
 		printf "%s%c", $0, 13
 	}
 ' |
 
 # Now each line is of the form
-# FILENAME YYYY/MM/DD HH:MM:SS AUTHOR \rLOG
+# FILENAME REVISION YYYY-MM-DD HH:MM:SS[+-TIMEZONE] AUTHOR \rLOG
 #	where \r stands for a carriage return,
 #	and each line of the log is terminated by \r instead of \n.
 # Sort the log entries, first by date+time (in reverse order),
-# then by author, then by log entry, and finally by file name (just in case).
-sort +1 -3r +3 +0 |
+# then by author, then by log entry, and finally by file name and revision
+# (just in case).
+sort +2 -4r +4 +0 |
 
 # Finally, reformat the sorted log entries.
-awk '
+$AWK '
 	BEGIN {
-		# Some awks do not understand "\r" or "\013", so we have to
+		logTZ = "'"$logTZ"'"
+		revision = "'"$revision"'"
+
+		# Some awk variants do not understand "\r" or "\013", so we have to
 		# put a carriage return directly in the file.
 		CR="
" # <-- There is a single CR between the " chars here.
 
@@ -357,19 +561,6 @@
 				indent_string = indent_string "\t"
 		while (1 <= i--)
 			indent_string = indent_string " "
-
-		# Set up date conversion tables.
-		# RCS uses a nice, clean, sortable format,
-		# but ChangeLog wants the traditional, ugly ctime format.
-
-		# January 1, 0 AD (Gregorian) was Saturday = 6
-		EPOCH_WEEKDAY = 6
-		# Of course, there was no 0 AD, but the algorithm works anyway.
-
-		w[0]="Sun"; w[1]="Mon"; w[2]="Tue"; w[3]="Wed"
-		w[4]="Thu"; w[5]="Fri"; w[6]="Sat"
-
-		'"$month_data"'
 	}
 
 	{
@@ -378,7 +569,7 @@
 		# Ignore log entries prefixed by "#".
 		if (newlog ~ /^#/) { next }
 
-		if (Log != newlog || date != $2 || author != $4) {
+		if (Log != newlog || date != $3 || author != $5) {
 
 			# The previous log and this log differ.
 
@@ -392,10 +583,10 @@
 			newclumpname = ""
 			sep = "\n"
 			if (date == "") sep = ""
-			if (newlog ~ /^\{[^	 }]*}[	 ]/) {
+			if (newlog ~ /^\{[^'"$tab"' }]*}['"$tab"' ]/) {
 				i = index(newlog, "}")
 				newclumpname = substr(newlog, 1, i)
-				while (substr(newlog, i+1) ~ /^[	 ]/) i++
+				while (substr(newlog, i+1) ~ /^['"$tab"' ]/) i++
 				newlog = substr(newlog, i+1)
 				if (clumpname == newclumpname) sep = ""
 			}
@@ -409,33 +600,25 @@
 					filesknown[i] = 0
 			files = ""
 		}
-		if (date != $2  ||  author != $4) {
+		if (date != $3  ||  author != $5) {
 			# The previous date+author and this date+author differ.
 			# Print the new one.
-			date = $2
-			author = $4
+			date = $3
+			time = $4
+			author = $5
 
-			# Convert nice RCS date like "1992/01/03 00:03:44"
-			# into ugly ctime date like "Fri Jan  3 00:03:44 1992".
-			# Calculate day of week from Gregorian calendar.
-			i = index($2, "/")
-			year = substr($2, 1, i-1) + 0
-			monthday = substr($2, i+1)
-			i = index(monthday, "/")
-			month = substr(monthday, 1, i-1) + 0
-			day = substr(monthday, i+1) + 0
-			leap = 0
-			if (2 < month && year%4 == 0 && (year%100 != 0 || year%400 == 0)) leap = 1
-			days_since_Sunday_before_epoch = EPOCH_WEEKDAY + year * 365 + int((year + 3) / 4) - int((year + 99) / 100) + int((year + 399) / 400) + mo[month-1] + leap + day - 1
+			zone = ""
+			if (logTZ && ((i = index(time, "-")) || (i = index(time, "+"))))
+				zone = " " substr(time, i)
 
-			# Print "date  fullname  (email address)".
+			# Print "date[ timezone]  fullname  <email address>".
 			# Get fullname and email address from associative arrays;
 			# default to author and author@hostname if not in arrays.
 			if (fullname[author])
 				auth = fullname[author]
 			else
 				auth = author
-			printf "%s %s %2d %s %d  %s  ", w[days_since_Sunday_before_epoch%7], m[month-1], day, $3, year, auth
+			printf "%s%s  %s  ", date, zone, auth
 			if (mailaddr[author])
 				printf "<%s>\n\n", mailaddr[author]
 			else
@@ -445,6 +628,7 @@
 			filesknown[$1] = 1
 			if (files == "") files = " " $1
 			else files = files ", " $1
+			if (revision && $2 != "?") files = files " " $2
 		}
 	}
 	END {
@@ -459,4 +643,8 @@
 
 # Exit successfully.
 
-exec rm -f $loginsout $rlogout
+exec rm -f $llogout $rlogout
+
+# Local Variables:
+# tab-width:4
+# End: